<script setup>
import Header from '@/Components/Header.vue';
import Popup from '@/Components/Unified/Popup.vue';
import { useForm, Link, router } from '@inertiajs/vue3'
import { onMounted } from 'vue';
import { store } from '@/store.js';
import draggable from "vuedraggable";
const props = defineProps({
    type: String,
    action: String,
    item: Object,
    materials: Object,
    measure_units: Object,
    children: [],
    action: String,
});
const types = {
    item: {
        name: 'Комплектующая',
        pad: 'комплектующую',
        link: 'items',
    },
    detail: {
        name: 'Деталь',
        pad: 'деталь',
        link: 'details',
    },
    equipment: {
        name: 'Оборудование',
        pad: 'оборудование',
        link: 'equipments',
    },
    custom: {
        name: 'Доп. оборудование',
        pad: 'доп. оборудование',
        link: 'customs',
    },
};

const form = useForm(
    props.action == 'edit' ?
        {
            id: props.item.id,
            name: props.item.name,
            article: props.item.article,
            material_id: props.item.material_id,
            measure_unit_id: props.item.measure_unit_id,
            weight: props.item.weight,
            image: null,
            price_per_unit: props.item.price_per_unit,
            image_id: props.item.image_id,
            comment: props.item.comment,
            cost_purchased: props.item.cost_purchased,
            price_date: props.item.price_date,
            price_history: props.item.price_history,
            children: [],
            previous: null,
        }
        :
        {
            id: null,
            name: null,
            article: null,
            material_id: null,
            measure_unit_id: null,
            weight: null,
            image: null,
            price_per_unit: null,
            image_id: null,
            comment: null,
            cost_purchased: null,
            price_date: null,
            price_history: null,
            children: [],
            previous: null,
        }
)
const tern = () => {
    store.detail.active = 1;
};
const onTorch = (item) => {
    item.measure_unit = props.measure_units[item.measure_unit-1].short_name;
    form.children.push(item);
}
function compareRanges(a, b) {
    return a.pivot.range - b.pivot.range;
}

const fixedSuccess = () => {

}

const fixedPost = () => {
    let link = '/' + types[props.type].link + (props.action == 'edit' ? '/update' : '');
    let infos = {
        onSuccess: fixedSuccess(),
    }
    router.post(link, form);
}

onMounted(() => {
    store.detail.active = 0;
    if (props.action == 'edit') {
        let items = props.item.children_items;
        let details = props.item.children_details;
        for (let el in items) {
            items[el].type = 'items';
        }
        for (let el in details) {
            details[el].type = 'details';
        }
        let children = items.concat(details).sort(compareRanges);
        children.map(x => {
            x.amount = x.pivot.amount;
            x.range = +x.pivot.range;
            x.parentid = x.pivot.id;
        })
        form.children = children;
    }
});
</script>

<template>
    <div class="fullwrap">
        <Header />
        <Popup @torched="onTorch" tabBasic="items" :forcomp="false"/>
        <div class="py-12">
            <div class="mx-auto max-w-7xl sm:px-6 lg:px-8">
                <div class="max-w-md p-8 mx-auto bg-white rounded-md shadow-md">
                    <Link :href='"/" + types[props.type].link' class="mb-4 closing">Назад</Link>
                    <h2 class="mb-6 text-2xl font-semibold">{{props.action == 'edit' ? 'Изменить' : 'Добавить'}} {{ types[props.type].pad }}</h2>
                    <form @submit.prevent="fixedPost()"
                        :disabled="form.processing" enctype="multipart/form-data" method="POST">
                        <div class="mb-4">
                            <label for="name" class="block mb-2 text-sm font-bold text-gray-700">Наименование</label>
                            <input type="text" id="name" name="name" placeholder="" required v-model="form.name"
                                class="w-full px-3 py-2 border rounded-md focus:outline-none focus:border-blue-500">
                        </div>
                        <div class="mb-4">
                            <label for="article" class="block mb-2 text-sm font-bold text-gray-700">Артикул</label>
                            <input type="text" id="article" name="article" placeholder="" v-model="form.article"
                                class="w-full px-3 py-2 border rounded-md focus:outline-none focus:border-blue-500">
                        </div>
                        <div class="mb-4">
                            <label for="material_id" class="block mb-2 text-sm font-bold text-gray-700">Материал</label>
                            <select type="text" id="material_id" name="material_id" required v-model="form.material_id"
                                class="w-full px-3 py-2 border rounded-md focus:outline-none focus:border-blue-500">
                                <option value="0" disabled>Выберите материал</option>
                                <template v-for="item in $page['props']['materials']">
                                    <option :value="item.id">{{ item.short_name }}</option>
                                </template>
                            </select>
                        </div>
                        <div class="mb-4">
                            <label for="measure_unit_id" class="block mb-2 text-sm font-bold text-gray-700">Единица
                                измерения</label>
                            <select type="text" id="measure_unit_id" name="measure_unit_id" required
                                v-model="form.measure_unit_id"
                                class="w-full px-3 py-2 border rounded-md focus:outline-none focus:border-blue-500">
                                <option value="0" disabled>Выберите единицу измерения</option>
                                <template v-for="item in $page['props']['measure_units']">
                                    <option :value="item.id">{{ item.short_name }}</option>
                                </template>
                            </select>
                        </div>
                        <div class="mb-4" v-if="props.type != 'equipment' && form.children.length == 0">
                            <label for="weight" class="block mb-2 text-sm font-bold text-gray-700">Вес</label>
                            <input type="text" id="weight" name="weight" placeholder="" v-model="form.weight"
                                class="w-full px-3 py-2 border rounded-md focus:outline-none focus:border-blue-500">
                        </div>
                        <div class="mb-4" v-if="props.type != 'equipment' && form.children.length == 0">
                            <label for="price_per_unit" class="block mb-2 text-sm font-bold text-gray-700">Цена
                                за
                                ед.</label>
                            <input type="text" id="price_per_unit" name="price_per_unit" placeholder=""
                                v-model="form.price_per_unit"
                                class="w-full px-3 py-2 border rounded-md focus:outline-none focus:border-blue-500">
                        </div>

                        <div class="mb-4">
                            <label class="block mb-2 text-sm font-bold text-gray-700" for="image">Выберите
                                фото</label>
                            <input
                                class="block w-full text-lg text-gray-900 border border-gray-300 rounded-lg cursor-pointer bg-gray-50 dark:text-gray-400 focus:outline-none dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400"
                                name="image" id="image" type="file" @input="form.image = $event.target.files[0]">
                        </div>

                        <div class="mb-4">
                            <label for="comment" class="block mb-2 text-sm font-bold text-gray-700">Комментарий</label>
                            <input type="text" id="comment" name="comment" placeholder="" v-model="form.comment"
                                class="w-full px-3 py-2 border rounded-md focus:outline-none focus:border-blue-500">
                        </div>
                        <h2 class="mb-4 text-2xl font-semibold">Состав</h2>
                        <div class="child__table">
                            <draggable v-model="form.children" tag="transition-group" item.key="element.range">
                                <template #item="{ element }">
                                    <div class="child__item">
                                        <div class="child__row">
                                            <div class="child__title">Наименование</div>
                                            <div class="child__value">{{ element.name }}</div>
                                        </div>
                                        <div class="child__row">
                                            <div class="child__title">Артикул</div>
                                            <div class="child__value">{{ element.article }}</div>
                                        </div>
                                        <div class="child__row">
                                            <div class="child__title">Тип</div>
                                            <div class="child__value">{{ store.names[element.type] }}</div>
                                        </div>
                                        <div class="child__row">
                                            <div class="child__title">Количество</div>
                                            <div class="child__value"><input type="number" v-model="element.amount">{{
                                                element.measure_unit }}
                                            </div>
                                        </div>
                                    </div>
                                </template>
                            </draggable>

                        </div>
                        <button @click.prevent="tern()"
                            class="w-full px-4 py-2 font-bold text-white bg-green-600 rounded-md btn search__tern hover:bg-green-800 focus:outline-none focus:shadow-outline-green">
                            Поиск
                        </button>
                        <button type="submit"
                            class="w-full px-4 py-2 font-bold text-white bg-blue-500 rounded-md hover:bg-blue-600 focus:outline-none focus:shadow-outline-blue">
                            Сохранить
                        </button>
                    </form>
                    <div class="my-4 text-2xl font-semibold">
                        История цен
                    </div>
                    <table class="history" v-if="form.price_history">
                        <tr class="history__header">
                            <th>
                                Дата
                            </th>
                            <th>
                                Цена
                            </th>
                        </tr>
                        <tr class="history__item" v-for="history in form.price_history">
                            <td>
                                {{ history.date }}
                            </td>
                            <td>
                                {{ history.price }}
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </div>
    </div>
</template>
